' Cube 3D Rotation with X.
' ------------------------
'
numLines = 11           ' 12 (0 to 11)
DIM lO(numLines,1,3)    ' AS pnt 'Original line coords
DIM lR(numLines,1,3)    ' AS pnt 'Rotated coords
DIM scrX(numLines,1)    ' screen x coord
DIM scrY(numLines,1)    ' screen y coord
DIM oldX(numLines,1)    ' old x coord for erasing
DIM oldY(numLines,1)    ' old y coord for erasing
DIM sj(359)             ' trig tables
DIM cj(359)

x = 0
y = 1
Z = 2
p = 3


FOR i = 0 TO 359:'              'create sine and cosine
   sj(i) = SIN(i * (PI / 180))  'look up tables to speed up
   cj(i) = COS(i * (PI / 180))  'the math
NEXT

' Read two points instead of one.
FOR i = 0 TO numLines
   READ lO(i,0,x), lO(i,0,y), lO(i,0,z), lO(i,0,p)
   READ lO(i,1,x), lO(i,1,y), lO(i,1,z), lO(i,1,p)
NEXT

CLS

xCenter = 160
yCenter = 100
zCenter = 256
theta = 0
phi = 0
thetaRot = 2
phiRot = 2
justStarted = 1

DO
  FOR i = 0 TO numLines
'      Save the old values of x and y so we can erase the balls later.
     oldX(i,0) = scrX(i,0): oldY(i,0) = scrY(i,0)
     oldX(i,1) = scrX(i,1): oldY(i,1) = scrY(i,1)
    
'      Rotate both points on each axis.
     lR(i,0,x) = -lO(i,0,x) * sj(theta) + lO(i,0,y) * cj(theta)
     lR(i,0,y) = -lO(i,0,x) * cj(theta) * sj(phi) - lO(i,0,y) * sj(theta) * sj(phi) - lO(i,0,z) * cj(phi) + lO(i,0,p)
     lR(i,0,z) = -lO(i,0,x) * cj(theta) * cj(phi) - lO(i,0,y) * sj(theta) * cj(phi) + lO(i,0,z) * sj(phi)

     lR(i,1,x) = -lO(i,1,x) * sj(theta) + lO(i,1,y) * cj(theta)
     lR(i,1,y) = -lO(i,1,x) * cj(theta) * sj(phi) - lO(i,1,y) * sj(theta) * sj(phi) - lO(i,1,z) * cj(phi) + lO(i,1,p)
     lR(i,1,z) = -lO(i,1,x) * cj(theta) * cj(phi) - lO(i,1,y) * sj(theta) * cj(phi) + lO(i,1,z) * sj(phi)

'      Translate both points from 3D to 2D.
     IF (lR(i,0,z) + zCenter) <> 0 THEN
       scrX(i,0) = 256 * (lR(i,0,x) / (lR(i,0,z) + zCenter)) + xCenter
       scrY(i,0) = 256 * (lR(i,0,y) / (lR(i,0,z) + zCenter)) + yCenter
     ENDIF

     IF (lR(i,1,z) + zCenter) <> 0 THEN
       scrX(i,1) = 256 * (lR(i,1,x) / (lR(i,1,z) + zCenter)) + xCenter
       scrY(i,1) = 256 * (lR(i,1,y) / (lR(i,1,z) + zCenter)) + yCenter
     ENDIF
  NEXT i

Pause 20

  IF justStarted = 0 THEN
'  Erase old lines.
    FOR i = 0 TO numLines
       LINE (oldX(i, 0), oldY(i, 0))-(oldX(i, 1), oldY(i, 1)), 0
    NEXT i
  EndIf

'  Erase old X.
       LINE (oldX(9, 0), oldY(9, 0))-(oldX(5, 0), oldY(5, 0)), 0
       LINE (oldX(1, 0), oldY(1, 0))-(oldX(8, 0), oldY(8, 0)), 0

' Draw new lines.
  FOR i = 0 TO numLines
     LINE (scrX(i, 0), scrY(i, 0))-(scrX(i, 1), scrY(i, 1)), 1
  NEXT i

' Draw X.
     LINE (scrX(9, 0), scrY(9, 0))-(scrX(5, 0), scrY(5, 0)), 1
     LINE (scrX(1, 0), scrY(1, 0))-(scrX(8, 0), scrY(8, 0)), 1

 
  theta = (theta + thetaRot) MOD 360
  phi = (phi + phiRot) MOD 360

  justStarted = 0
LOOP UNTIL INKEY$ = CHR$(27)
End

'****************************

' Lines are stored in format (X1,Y1,Z1,p1)-(X2,Y2,Z2,p2)
DATA -50,50,50,1,50,50,50,1
DATA 50,-50,50,1,50,50,50,1
DATA 50,50,-50,1,50,50,50,1
DATA -50,-50,50,1,-50,50,50,1
DATA -50,50,-50,1,-50,50,50,1
DATA -50,-50,50,1,50,-50,50,1
DATA -50,50,-50,1,50,50,-50,1
DATA -50,-50,-50,1,50,-50,-50,1
DATA -50,-50,-50,1,-50,50,-50,1
DATA 50,-50,-50,1,50,-50,50,1
DATA 50,-50,-50,1,50,50,-50,1
DATA -50,-50,-50,1,-50,-50,50,1

'****************************
' PRG END
'****************************
